library STD, IEEE;
use STD.TEXTIO.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_textio.all;

entity TESTBENCH_FFT64 is
end TESTBENCH_FFT64;

architecture SIM_DATA of TESTBENCH_FFT64 is

component FFT64
  port (
    RESET      : in  std_logic;
    CLK        : in  std_logic;
    HEAD       : in  std_logic;                      -- <1,1,u>
    FFTIN_I    : in  std_logic_vector(13 downto 0);  -- <14,6,t>
    FFTIN_Q    : in  std_logic_vector(13 downto 0);  -- <14,6,t>
    OUTHEAD    : out std_logic;                      -- <1,1,u>
    FFTOUT_I   : out std_logic_vector(13 downto 0);  -- <14,6,t>
    FFTOUT_Q   : out std_logic_vector(13 downto 0)); -- <14,6,t>
end component;

signal CLK        : std_logic := '0';
signal RESET      : std_logic := '1';
signal HEAD       : std_logic := '0';
signal OUTHEAD    : std_logic := '0';
signal FFTIN_I    : std_logic_vector(13 downto 0);
signal FFTIN_Q    : std_logic_vector(13 downto 0);
signal FFTOUT_I   : std_logic_vector(13 downto 0);
signal FFTOUT_Q   : std_logic_vector(13 downto 0);

signal FFTIN_I_R   : real :=0.0 ;
signal FFTIN_Q_R   : real :=0.0 ;
signal FFTOUT_I_R  : real :=0.0 ;
signal FFTOUT_Q_R  : real :=0.0 ;

begin

-- Sysetem CLK generation
      CLK <= not CLK after 5 ns;

-- DUT
  FFT0: FFT64 port map (RESET, CLK, HEAD, FFTIN_I, FFTIN_Q, OUTHEAD, FFTOUT_I, FFTOUT_Q);

-- REAL SIGNAL MONITOR
FFTIN_I_R  <= real(CONV_INTEGER(signed(FFTIN_I))) /(2.0**7);
FFTIN_Q_R  <= real(CONV_INTEGER(signed(FFTIN_Q))) /(2.0**7);
FFTOUT_I_R <= real(CONV_INTEGER(signed(FFTOUT_I))) /(2.0**7);
FFTOUT_Q_R <= real(CONV_INTEGER(signed(FFTOUT_Q))) /(2.0**7);

-- TEST VECTOR
  P1: process
      --file TEST_IN_I  : text is in "FFTIN0REAL.txt";
      --file TEST_IN_Q  : text is in "FFTIN0IMAG.txt";
      --file TEST_IN_I  : text is in "FFTIN1REAL.txt";
      --file TEST_IN_Q  : text is in "FFTIN1IMAG.txt";
      --file TEST_IN_I  : text is in "FFTIN1JREAL.txt";
      --file TEST_IN_Q  : text is in "FFTIN1JIMAG.txt";
      --file TEST_IN_I  : text is in "FFTIN1COSREAL.txt";
      --file TEST_IN_Q  : text is in "FFTIN1COSIMAG.txt";      
      file TEST_IN_I  : text is in "FFTIN15REAL.txt";
      file TEST_IN_Q  : text is in "FFTIN15IMAG.txt";
      variable LINE_IN_I : line;
      variable LINE_IN_Q : line;
      variable V_IN_I : std_logic_vector(7 downto 0);
      variable V_IN_Q : std_logic_vector(7 downto 0);
  begin
      wait for 50 ns;
      RESET <= '0';
      for K in 0 to 10 loop
        for I in 0 to 63 loop
          if (K=0) then
            if endfile(TEST_IN_I) then
             NULL;
            else 
            readline(TEST_IN_I, LINE_IN_I);
            readline(TEST_IN_Q, LINE_IN_Q);
            read(LINE_IN_I, V_IN_I);
            read(LINE_IN_Q, V_IN_Q);
            FFTIN_I <= V_IN_I(7)&V_IN_I(7)&V_IN_I(7)&V_IN_I(7)&V_IN_I(7)&V_IN_I(7)&V_IN_I;
            FFTIN_Q <= V_IN_Q(7)&V_IN_Q(7)&V_IN_Q(7)&V_IN_Q(7)&V_IN_Q(7)&V_IN_Q(7)&V_IN_Q;
            end if;
          end if;
          if (I = 0) then HEAD <= '1';
            else HEAD <= '0';
          end if;
          wait for 10 ns;
        end loop;
     end loop;

  end process;

end SIM_DATA;

configuration CFG_FFT64 of TESTBENCH_FFT64 is
  for SIM_DATA
  end for;
end;

